KTar Class Reference

`#include <ktar.h>`

Inheritance diagram for KTar:

## Public Member Functions

| KTar (const QString &filename, const QString &mimetype=QString::null)
| KTar (QIODevice *dev)
virtual | ~KTar ()
QString | fileName ()
void | setOrigFileName (const QCString &fileName)
bool | writeSymLink (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
virtual bool | writeDir (const QString &name, const QString &user, const QString &group)
bool | writeDir (const QString &name, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
virtual bool | prepareWriting (const QString &name, const QString &user, const QString &group, uint size)
bool | prepareWriting (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
virtual bool | doneWriting (uint size)
Public Member Functions inherited from KArchive
virtual bool | open (int mode)
virtual void | close ()
bool | closeSucceeded () const
bool | isOpened () const
int | mode () const
QIODevice * | device () const
const KArchiveDirectory * | directory () const
bool | addLocalFile (const QString &fileName, const QString &destName)
bool | addLocalDirectory (const QString &path, const QString &destName)
bool | writeDir (const QString &name, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeSymLink (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
virtual bool | writeFile (const QString &name, const QString &user, const QString &group, uint size, const char *data)
bool | writeFile (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime, const char *data)
bool | prepareWriting (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeData (const char *data, uint size)

## Protected Member Functions

virtual bool | openArchive (int mode)
virtual bool | closeArchive ()
virtual void | virtual_hook (int id, void *data)
bool | prepareWriting_impl (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeDir_impl (const QString &name, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeSymLink_impl (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
Protected Member Functions inherited from KArchive
| KArchive (QIODevice *dev)
virtual KArchiveDirectory * | rootDir ()
KArchiveDirectory * | findOrCreate (const QString &path)
void | setDevice (QIODevice *dev)
void | setRootDir (KArchiveDirectory *rootDir)
bool | prepareWriting_impl (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeFile_impl (const QString &name, const QString &user, const QString &group, uint size, mode_t perm, time_t atime, time_t mtime, time_t ctime, const char *data)
bool | writeDir_impl (const QString &name, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeSymLink_impl (const QString &name, const QString &target, const QString &user, const QString &group, mode_t perm, time_t atime, time_t mtime, time_t ctime)
bool | writeData_impl (const char *data, uint size)

## Additional Inherited Members

Protected Types inherited from KArchive
enum | { VIRTUAL_WRITE_DATA = 1, VIRTUAL_WRITE_SYMLINK, VIRTUAL_WRITE_DIR, VIRTUAL_WRITE_FILE, VIRTUAL_PREPARE_WRITING }

## Detailed Description

A class for reading / writing (optionally compressed) tar archives.

KTar allows you to read and write tar archives, including those that are compressed using gzip or bzip2.

Author
  Torben Weis weis@.nosp@m.kde..nosp@m.org, David Faure faure.nosp@m.@kde.nosp@m..org

Definition at line 40 of file ktar.h.

## Constructor & Destructor Documentation

KTar::KTar | ( | const QString & | filename,
|  | const QString & | mimetype = `QString::null`
| ) |  |

Creates an instance that operates on the given filename using the compression filter associated to given mimetype.

Parameters

  filename | is a local path (e.g. "/home/weis/myfile.tgz")
  mimetype | "application/x-gzip" or "application/x-bzip2" Do not use application/x-tgz or similar - you only need to specify the compression layer ! If the mimetype is omitted, it will be determined from the filename.

Definition at line 59 of file ktar.cpp.

KTar::KTar | ( | QIODevice * | dev | ) |

Creates an instance that operates on the given device.

The device can be compressed (KFilterDev) or not (QFile, etc.).

Warning
  Do not assume that giving a QFile here will decompress the file, in case it's compressed!

Parameters

  dev | the device to read from. If the source is compressed, the QIODevice must take care of decompression

Definition at line 142 of file ktar.cpp.

KTar::~KTar | ( |  | ) |

virtual

If the tar ball is still opened, then it will be closed automatically by the destructor.

Definition at line 149 of file ktar.cpp.

## Member Function Documentation

bool KTar::closeArchive | ( |  | ) |

protected virtual

Closes the archive.

Called by close.

Implements KArchive.

Definition at line 534 of file ktar.cpp.

bool KTar::doneWriting | ( | uint | size | ) |

virtual

Call doneWriting after writing the data.

Parameters

  size | the size of the file

See also
  prepareWriting()

Implements KArchive.

Definition at line 617 of file ktar.cpp.

QString KTar::fileName | ( |  | ) |

inline

The name of the tar file, as passed to the constructor Null if you used the QIODevice constructor.

Returns
  the name of the file, or QString::null if unknown

Definition at line 76 of file ktar.h.

bool KTar::openArchive | ( | int | mode | ) |

protected virtual

Opens the archive for reading.

Parses the directory listing of the archive and creates the KArchiveDirectory/KArchiveFile entries.

Parameters

  mode | the mode of the file

Implements KArchive.

Definition at line 330 of file ktar.cpp.

bool KTar::prepareWriting | ( | const QString & | name,
|  | const QString & | user,
|  | const QString & | group,
|  | uint | size
| ) |  |

virtual

Here's another way of writing a file into an archive: Call prepareWriting, then call writeData() as many times as wanted then call doneWriting( totalSize ).

For tar.gz files, you need to know the size before hand, since it is needed in the header. For zip files, size isn't used.

Parameters

  name | the name of the file
  user | the user that owns the file
  group | the group that owns the file
  size | the size of the file

Todo:
  TODO(BIC): make this a thin non-virtual wrapper around prepareWriting(name,user,group,size,perm,atime,mtime,ctime) or eliminate it.

Implements KArchive.

Definition at line 609 of file ktar.cpp.

void KTar::setOrigFileName | ( | const QCString & | fileName | ) |

Special function for setting the "original file name" in the gzip header, when writing a tar.gz file.

It appears when using in the "file" command, for instance. Should only be called if the underlying device is a KFilterDev!

Parameters

  fileName | the original file name

Definition at line 164 of file ktar.cpp.

bool KTar::writeDir | ( | const QString & | name,
|  | const QString & | user,
|  | const QString & | group
| ) |  |

virtual

If an archive is opened for writing then you can add new directories using this function.

KArchive won't write one directory twice.

Parameters

  name | the name of the directory
  user | the user that owns the directory
  group | the group that owns the directory

Todo:
  TODO(BIC): make this a thin wrapper around writeDir(name,user,group,perm,atime,mtime,ctime) or eliminate it

Implements KArchive.

Definition at line 547 of file ktar.cpp.

The documentation for this class was generated from the following files:

- ktar.h
- ktar.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys